-= New-Tracker V1.00 (C)1995 Simon VOLANT =-

DOCUMENTATION RAPIDE DE RFRENCE.  UTILISER LORS DE L'TUDE DE SCRIPT,
DE DVELOPPEMENT DE SCRIPTS, ....



*********************************************************************
GENERAL:
*********************************************************************

SYSTEME D'INCLUSION DES FICHIERS
********************************

[INCLUDE]:permet d'inclure un fichier extrieur
ex: include="amiga.inc"
    Le lecteur de script va lire le fichier "amiga.inc"

SYSTEME D'ALIAS
***************

[ALIAS]:permet de dfinir une note
ex: alias do=1!
    le "do" est gal  la frquence de base





*********************************************************************
DESCRIPTION D'UN NOUVEAU SON:
*********************************************************************

SAMPLE=SampleName  => NOM DU SAMPLE TEL QU'IL SERA RECONNU PAR LA SUITE
{
 FILE=filename     => LE NOM DU FICHIER
 FRQ=[0..+]        => FRQUENCE DE BASE DU SON
 VOL=[0..1],[0..1] => VOLUME PAR DEFAUT (L'UN A GAUCHE ET L'AUTRE A DROITE)
ou
 VOL=[0..1]        => VOLUME PAR DEFAUT (POUR LA GAUCHE ET LA DROITE)
 ADR=[0..+],[0..+],[0..+],[0..+]
        +------+=> (<)ADRESSE DE DEBUT ET FIN DE L'ATTAQUE
               +------+=> (=)ADRESSE DE DEBUT ET FIN DU LOOP
                      +------+=> (>)ADRESSE DE DEBUT ET FIN DE LA CHUTTE
}

[SAMPLE]:POUR COMMENCER LA DCLARATION D'UN SON

[FILE]:(OBLIGATOIRE)LE FICHIER 16BITS/STEREO CORRESPONDANT

[FRQ]:(OBLIGATOIRE)LA FREQUENCE D'ECHANTILLONAGE DU FICHIER SON

[VOL]:(1 PAR DEFAUT)LE VOLUME DU SON A PRENDRE S'IL N'EST PAS SPCIFI
      DANS LA PARTITION

[ADR]:ADRESSES DE REPERAGE DANS LE FICHIER.
      3 TYPE DE SON
      -UNE ATTAQUE SEUL: 0,32000
      -UNE ATTAQUE PUIS UN LOOPING: 0,32000,64000
      -UNE ATTAQUE PUIS UN LOOPING DONT ON POURRA RESORTIR SUR UNE CHUTTE
       0,32000,64000,-1
      NOTE: LE -1 SERA REMPLACER PAR LA LONGUEUR DU FICHIER.
      PAR DEFAUT: LA STRUCTURE EST 0,-1,-1,-1 C'EST  DIRE QUE L'ON JOUE 
      TOUT LE FICHIER EN ATTAQUE.      





*********************************************************************
DESCRIPTION D'UNE NOUVELLE PARTITION:
*********************************************************************	

PATTERN=PatternName  => NOM DE LA PARTITION
{
 ([SampleName] [Partie]:[Note] [Transition]:[volume] [Transition])
}


	
STRUCTURE DE LA LIGNE:
**********************
	
3 PARTIES:
(INSTRUMENT+PARTIE:NOTES/OCTAVES+TRANSITIONS:VOLUMES+TRANSITIONS)
      |       |      |                          +-> Le volume va de 0  1
      |       |      |                              0:minimum
      |       |      |                              1:maximum
      |       |      |                              Par dfaut, on prend le
      |       |      |                              volume spcifi dans
      |       |      |                              SAMPLE.
      |       |      +-> La note est dfinie comme tant un multiple
      |       |          de la frquence de base. On note 1! la frquence
      |       |          de base d'un chantillon, .5! la moitie, 2! le
      |       |          double. Il est plus commode d'utiliser les ALIAS
      |       |          afin de dclarer les macros (CF amiga.inc).
      |       +-> Partie de l'on dsire jouer
      |           < : ON UTILISE LE SON DEPUIS L'ATTAQUE (DFAUT)
      |               SI IL Y A UN LOOP, LE SAMPLE BOUCLERA DANS
      |               LE LOOPING AUTOMATIQUE APRES AVOIR FAIT L'ATTAQUE
      |           = : ON REPREND LE SON DEPUIS LE LOOP 
      |               (POUR SAUTER L'ATTAQUE)
      |           > : ON ENGAGE LE SON DANS LA CHUTTE (PENDANT UN LOOPING)
      |               LE SONS NE BOUCLE PLUS ET PARCOURT LA DERNIERE
      |               PARTIE AVANT DE S'ARRETER.
      |           * : ON COUPE LE SON
      +-> Nom de l'chantillon (dclarer en SAMPLE) que l'on dsire
          utiliser.



DCLARATION DE VOLUME ET FRQUENCE:
***********************************

ON DCLARE UN SAMPLE POUR L'EXEMPLE:
SAMPLE=PAN
{
 FILE=F:\PAN.INS * NOM DU FICHIER
 FRQ=49170       * FREQUENCE DE BASE
 ADR=0,-1        * IL N'Y A QU'UNE ATTAQUE
}

G,D        => VOLUME/FRQUENCE A GAUCHE ET A DROITE
              EX: (PAN <:1!,1.1!:)

                  (PAN <:1!:.5,1)

G,         => VOLUME/FRQUENCE A GAUCHE
              EX: (PAN <:1.5!,:)

                  (PAN <:1!:.5,)

,D         => VOLUME/FRQUENCE A DROITE
              EX: ALIAS DO=1!  *DCLARATION D'UN ALIAS
                  (PAN <:,DO:)

                  (PAN <:1!:,1)

V          => VOLUME/FRQUENCE GAUCHE,DROITE
              EX: ALIAS DO=49170 *ON NE S'OCCUPE PAS DE LA FRQUENCE DE BASE
                  (PAN:DO:)      *LE < EST PRIS PAR DFAUT

                  (PAN <:1!:.5)


	
DCLARATION DE TRANSITION:
**************************

&G,&D      => TRANSITION DU VOLUME/FRQUENCE SUR LA DURE DE LA NOTE
              JUSQU' G  GAUCHE ET  D  DROITE
              EX: (PAN: 1! &1.1!,&1.2!:)
                   LE SAMPLE COMMENCE  LA FRQUENCE DE BASE  GAUCHE ET 
                   DROITE PUIS VA MONTER  1.1!  GAUCHE ET  1.2!  DROITE.

                  (PAN:1!:.5 &.75,&25)
                   LE SAMPLE COMMENCE AU VOLUME .5  GAUCHE ET  DROITE PUIS
                   VA MONTER  .75  GAUCHE ET DESCENDRE  .25!  DROITE.

&G,        => TRANSITION DU VOLUME/FRQUENCE
              JUSQU' G  GAUCHE SUR LA DURE DE LA NOTE
              EX: (PAN: 1! &1.1!,:)
                   LE SAMPLE COMMENCE  LA FRQUENCE DE BASE  GAUCHE ET 
                   DROITE PUIS VA MONTER  1.1!  GAUCHE.

                  (PAN:1!:.5 &.75,)
                   LE SAMPLE COMMENCE AU VOLUME .5  GAUCHE ET  DROITE PUIS
                   VA MONTER  .75  GAUCHE.

,&D        => TRANSITION DU VOLUME/FRQUENCE
              JUSQU' D  DROITE SUR LA DURE DE LA NOTE
              EX: (PAN: 1! &1.1!,&1.2!:)
                   LE SAMPLE COMMENCE  LA FRQUENCE DE BASE  GAUCHE ET 
                   DROITE PUIS VA MONTER  1.2!  DROITE.

                  (PAN:1!:.5 ,&25)
                   LE SAMPLE COMMENCE AU VOLUME .5  GAUCHE ET  DROITE PUIS
                   VA DESCENDRE  .25!  DROITE.

&V         => TRANSITION DU VOLUME/FRQUENCE
              JUSQU' V  GAUCHE ET  DROITE SUR LA DURE DE LA NOTE
              EX: (PAN: 1! &1.5!:)
                   LE SAMPLE COMMENCE  LA FRQUENCE DE BASE  GAUCHE ET 
                   DROITE PUIS VA MONTER 1.5!  GAUCHE ET  DROITE.

                  (PAN:1!:.5 &.75)
                   LE SAMPLE COMMENCE AU VOLUME .5  GAUCHE ET  DROITE PUIS
                   VA MONTER  .75  GAUCHE ET  DROITE.



N&G,N'&D   => TRANSITION DU VOLUME/FRQUENCE 
              JUSQU' G  GAUCHE ET EN N SECONDES
              ET JUSQU' D  DROITE EN N' SECONDE

N&G,       => TRANSITION DU VOLUME/FRQUENCE 
              JUSQU' G  GAUCHE ET EN N SECONDES

,N'&D      => TRANSITION DU VOLUME/FRQUENCE 
              JUSQU' D  DROITE EN N' SECONDE

N&V        => TRANSITION DU VOLUME/FRQUENCE 
              JUSQU' V  GAUCHE ET A DROITE EN N SECONDES

* NON DISPONIBLE POUR L'INSTANT !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*A~F        => VIBRATO (SINUS) D'AMPLITUDE A ET DE FREQUENCE F
*&A'~&F'    => TRANSITION VIBRATO (SINUS) D'AMPLITUDE A' ET DE FREQUENCE F'
*N&A'~N'&F' => TRANSITION VIBRATO (SINUS) D'AMPLITUDE A' ET DE FREQUENCE F'
*AF        => VIBRATO (COSINUS) D'AMPLITUDE A ET DE FREQUENCE F
*&A'&F'    => TRANSITION VIBRATO (COSINUS) D'AMPLITUDE A' ET DE FREQUENCE F' EN N ET N' SECONDE
*N&A'N'&F' => TRANSITION VIBRATO (COSINUS) D'AMPLITUDE A' ET DE FREQUENCE F' EN N ET N' SECONDE



STRUCTURE D'UN LIGNE SIMPLE:
----------------------------
INSTRUMENT:NOTE+OCTAVE:VOLUME
 => (FPAN:DO1:.75) = LE SAMPLE COMMENCE A L'ATTAQUE (< PAR DFAUT)
                     DO OCTAVE 1 (DCLAR EN ALIAS), VOLUME .75
                     TOUS SES RGLAGES SONT FAITS A GAUCHE ET A DROITE


	
STRUCTURES DE LIGNES COMPLEXES:
-------------------------------

INSTRUMENT:NOTES+OCTAVES:VOLUMES
 => (FPAN <:DO1,DO#1:.75,1) = DO OCTAVE 1 A GAUCHE, DO # OCTAVE 1 A DROITE
                              VOLUME .75 A GAUCHE, 1 A DROITE

INSTRUMENT:NOTES+OCTAVES:VOLUMES
 => (>:&RE1:5&0) = LE SAMPLE VA S'ACHEVER (IL ETAIT EN LOOPING)
                   TRANSITION EN RE OCTAVE 1  GAUCHE ET  DROITE
	           VOLUME DESCENDANT  0 EN 5 SECONDES

[PATTERN]:POUR COMMENCER LA DCLARATION D'UNE PARTITION





*********************************************************************
DESCRIPTION DU PROCESSUS DE COMPILATION:
*********************************************************************	

COMPILE           => SECTION COMPILATION
{
 FILE=D2DFileName => NOM DU FICHIER D2D EN SORTIE
 FRQ=[0..+]       => FRQUENCE DE SORTIE
 TRACK=[0..+]     => NOMBRE DE PISTES UTILIES DANS LES PATTERNS 
                     SUIVANTES (A CALCULER)
 TEMPO=[0..+]     => TEMPO
 BOOST=[0..1]     => VOLUME (BOOST) 0:NORMAL 1:SATUR
 MAKE=PatternName => PARTITION A CALCULER DANS LE FICHIER FileName
}

[COMPILE]:DCLARATION UNIQUE DE LA COMPILATION

[FILE]:FICHIER DANS LEQUEL ON ECRIRA LES CALCULS

[FRQ]:FRQUENCE  LAQUELLE ON SORT

[TRACK]:NOMBRE DE PISTES UTILISES
        CETTE COMMANDE RINITIALISE LES PISTES  0.
        ATTENTION, UNE NOTE INDSIRE EN LOOPING PEUT SE PROLONGER
        D'UNE PATTERN  UNE AUTRE SI VOUS NE RINITIALISEZ PAS ENTRE LE
        CALCUL DE SES 2 PARTITIONS.

[TEMPO]:TEMPO EN NOTE/MINUTES

[BOOST]: 0 PAR DFAUT

[MAKE]:LANCE LE CALCUL D'UNE PARTITION
       JE VOUS CONSEILLE D'UTILISER UN FICHIER PAR PARTITION AINSI LE
       MONTAGE SERA FACILIT ET LA MODIFICATION DE NOTES VOUS EVITERA
       DE TOUT RECALCULER.





*********************************************************************
DESCRIPTION DU PROCESSUS DE COMPILATION:
*********************************************************************

LINK=FinalFinalName  => NOM DU FICHIER OU L'ON STOCKERA LE MONTAGE
{
 FILE=D2DFileName    => FICHIERS 16BITS/STEREO A INCLURE
}

[LINK]:DCLARATION UNIQUE DE L'ASSEMBLAGE

[FILE]:FICHIER  INCLURE DANS LE FICHIER FINAL





*********************************************************************
TRUCS ET ASTUCES DE L'AUTEUR:
*********************************************************************	

-UN FICHIER DUREMENT CALCUL PEUT DEVENIR UN SAMPLE
 EX: VOUS CALCULEZ UNE FOIS POUR TOUTE VOTRE BATTERIE DANS UN SCRIPT A
     ET VOUS L'UTILISEZ DANS UN SCRIPT B EN TEMPS QU'INSTRUMENT.
     VOUS POUVEZ ALORS FAIRE PLEIN D'EFFETS SUR CE SAMPLE (VARIATION DE
     FRQUENCE, VOLUME, ...).
